/* 
** DESCRIPTION: Rahmen fr MPI-Programme
** COMPILE:     mpic++ -o rahmen rahmen.cpp
** RUN:         mpiexec -n 3 -machinefile machines $PWD/rahmen arg1 arg2 ...
*/

#include <iostream>
#include <stdlib.h>
#include <mpi.h>

using namespace std;

int main (int argc, char **argv)
{
	int i;
	int myrank, nprocs;
	int namelen;
	char name[MPI_MAX_PROCESSOR_NAME];

	cout << "-- Arguments: ";
	for (i = 0; i<argc; i++)
		cout << argv[i] << " ";
	cout << "\n";

	/* MPI initialisieren und Argumente setzen */ 
	MPI_Init(&argc, &argv);

	/* Anzahl der Prozesse erfragen */
	MPI_Comm_size(MPI_COMM_WORLD, &nprocs);

	/* Eigenen Rang erfragen */
	MPI_Comm_rank(MPI_COMM_WORLD, &myrank);

	/* Rechnernamen erfragen */
	MPI_Get_processor_name(name, &namelen);

	/* flush, damit Ausgabe sofort kommt */
	cout << "Process " << myrank << "/" << nprocs << "started on " << name << "\n" << flush;

	cout << "-- Arguments: ";
	for (i = 0; i<argc; i++)
		cout << argv[i] << " ";
	cout << "\n";

	/* MPI geordnet beenden */
	MPI_Finalize();

	return 0;
}

